Subject: Re: [GIT PULL] linux-firmware: mrvl: prestera: Update Marvell Prestera Switchdev v3.0 with policer support

From: Vadym Kochan <[email-masked]>
Date: Thu, 17 Jun 2021 19:58:24 +0300

Hi Andrew,

On Thu, Jun 17, 2021 at 06:45:14PM +0200, Andrew Lunn wrote:
> On Thu, Jun 17, 2021 at 06:42:06PM +0300, Vadym Kochan wrote:
> > The following changes since commit 0f66b74b6267fce66395316308d88b0535aa3df2:
> > 
> >   cypress: update firmware for cyw54591 pcie (2021-06-09 07:12:02 -0400)
> > 
> > are available in the Git repository at:
> > 
> >   https://github.com/PLVision/linux-firmware.git mrvl-prestera
> > 
> > for you to fetch changes up to a43d95a48b8e8167e21fb72429d860c7961c2e32:
> > 
> >   mrvl: prestera: Update Marvell Prestera Switchdev v3.0 with policer support (2021-06-17 18:22:57 +0300)
> > 
> > ----------------------------------------------------------------
> > Vadym Kochan (1):
> >       mrvl: prestera: Update Marvell Prestera Switchdev v3.0 with policer support
> > 
> >  mrvl/prestera/mvsw_prestera_fw-v3.0.img | Bin 13721584 -> 13721676 bytes
> >  1 file changed, 0 insertions(+), 0 deletions(-)
> 
> Hi Vadym
> 
> You keep the version the same, but add new features? So what does the
> version number actually mean? How does the driver know if should not
> use the policer if it cannot tell old version 3.0 from new version
> 3.0?  How is a user supposed to know if they have old version 3.0
> rather than new 3.0, when policer fails?
> 
>     Andrew

So the last 'sub' x.x.1 version will be showed in dmesg output and via:

    $ ethtool -i $PORT

    ...
    firmware-version: 3.0.1
    ...

The older driver version will not use the policer feature. I am not sure
if I need to add a check for 3.0.1 in the newer one which will have the
policer changes. So may be the only case which can be handled (in new
driver changes with policer code) is to check if the FW is not older
than 3.0.1 during the validation of police rules.

For this reason I decided to do not increase the supported version
MIN.MAJ but only the SUB (last one).